=== debian/changelog ===
fastdds (3.0.0+ds-3) unstable; urgency=medium

  * Fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Wed, 28 Aug 2024 22:29:47 +0200

fastdds (3.0.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Wed, 28 Aug 2024 10:32:23 +0200

fastdds (3.0.0+ds-1) experimental; urgency=medium

  * New upstream version 3.0.0+ds
  * libfastrtps has been renamed to libfastdds

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Aug 2024 22:26:31 +0200

fastdds (2.14.3+ds-1) unstable; urgency=medium

  * New upstream version 2.14.3+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Jul 2024 22:44:02 +0200
