=== debian/tests/control ===
Tests: run-test-suite
Depends:
 cmake,
 g++,
 gcc,
 libfastdds-dev,
 libgmock-dev,
 libgtest-dev,
 nlohmann-json3-dev,
 python3,
Restrictions: allow-stderr
